#include <dos.h>
#include <string.h>
#include <stdio.h>
#include <ldev.h>


short win[3][4]={ 
      { 2, 6, 39, 18 },
      { 42, 6, 78, 18 },
      { 20, 1, 60, 19 }
};

void draw_title();
void draw_win(char which,char mode);
void draw_message();
void draw_all();

struct 
{ short count,start;
  char names[1000][20];
  long sizes[1000];
} selects[2];

short select_num=0,select_win=0,select_line[2]={0,0};

LPAUDIOWAVE	lpWave=NULL;
LPAUDIOMODULE   lpModule=NULL;
HAC             hVoice;
MIDI           *midi=NULL;

short load_files(char which);
void  view_selects(char which);
void  send_message(char *message);
void  controller();
void  stop_wave();

char  *notice[200]={
  "            LinPlayer (Demo)  \n\n",
  "_______________________________________",
  "   IT SUPPORTS .MID .WAV .S3M PLAYING\n",
  "     If you want to get the source\n",
  "       files just write to me:\n",
  "    lwwind@yeah.net or (0871)7167710\n",
  "      I hope you would like it :->\n",
  "_______________________________________",
  "\n",
  "  This is a sound file player for DOS,\n",
  "which is written in WATCOM C++ 10.0.\n",
  "  At first, It use the FM synth to play",
  "midi if you have a OPL3 or higher. In\n",
  "the demo version, it could't use wave\n",
  "table or MPU401, so the midi effect is\n",
  "not very good.\n",
  "  But LinPlayer will be much more exc-\n",
  "iting when playing the wave or module\n", 
  "file for it uses 44100Hz 16Bits Stereo\n",
  "sound mode.\n",
  "\n",
  "  Do you like playing games ? If so or\n",
  "do you like writing game program ? If\n",
  "so, would you like to make me a friend\n",
  "\n",
  "                   ------ just mail me\n",
  "                       lwwind@yeah.net\n",
  "\n","\n","\n","\n","\n","\n",
  "          - END ESC TO QUIT -\n",
  "\n","\n","\n","\n","\n","\n","\n","\n",
  "\n","\n",
  0
};

void main()
{ char flag=0;
  char screen[80*25*2];
  char line[100];
  short sb_port,sb_dma8,sb_dma16,sb_irq,i,j,x,y;
  AUDIOINFO info;

  lk_text_init(3,80,25);
  lk_copy_data(0,0,79,24,screen,0);
  
  draw_all(); view_selects(0); view_selects(1);
  send_message("Init your sound card: ");
  lsGetBlasterEnv(&sb_port,&sb_dma8,&sb_dma16,&sb_irq);
  if (sb_port<0) 
  {  send_message("\nOh sorry, I can not read your sound card environment");
     send_message("\nTry to type SET BLASTER=A220 I5 D1 in MS-DOS mode");
     flag=1; goto end; 
  }
  sprintf(line,"port=%xh dma=%d irq=%d",sb_port,sb_dma8,sb_irq); send_message(line);
  lk_sb_port=sb_port; lsResetDsp(1);
  sprintf(line,", dsp version %xh",lsGetDspVersion()); send_message(line);
  send_message("\nInit FM synth and loading sound files....");
  if (!lmMidiInit(MIDI_ADLIB)) {
     flag=1; goto end;
  } 
  lsSetMixer(255,255);
  select_num=load_files(0)+load_files(1);
  if (select_num==0) {
     flag=2; goto end;
  }
  send_message("ok");
  if (selects[0].count==0) select_win=1;
  if (selects[1].count==0) select_win=0;
  view_selects(0); view_selects(1);
  
  AInitialize();

  info.nDeviceId = AUDIO_DEVICE_MAPPER;
  info.wFormat = AUDIO_FORMAT_16BITS | AUDIO_FORMAT_STEREO;
  info.nSampleRate = 44100;  
  
  AOpenAudio(&info);

  controller();

  lmMidiRest();  
  stop_wave();
  ACloseAudio();
  
  lk_setcolor(7,1);
  lk_draw_window(win[2][0],win[2][1],win[2][2],win[2][3],"NOTICE",0);
  lk_setwindow(win[2][0]+1,win[2][1]+1,win[2][2]-1,win[2][3]-1);
  lk_clear(0); while (lkpressed()) lkgetch(0);
  for (i=0,x=0,y=0;y!=win[2][3]-win[2][1]-2 && notice[i];i++) 
    { lk_puts(notice[i]);
      lk_getxy(&x,&y);
    }
  for (j=0;j==0;) {
      if (lkgetch(0)==27) j=1;
      else if (notice[i]) lk_puts(notice[i++]);
  }
end:
  lk_copy_data(0,0,79,24,screen,1);
  printf("\ngoodbye !\n");
  if (flag==1) printf("Sorry, I can not init your sound card\n");
  if (flag==2) printf("Sorry, I can not find any .mid .wav .mod .s3x or .xm files\n");
}
void stop_wave()
{ if (lpWave) AStopVoice(hVoice);
  if (lpModule) AStopModule();
  ACloseVoices();
  AFreeWaveFile(lpWave); lpWave=NULL;
  AFreeModuleFile(lpModule); lpModule=NULL;
}
void play_a_wave(char *fname)
{ short i,j,mode=2; char word[100];
  if (fname[strlen(fname)-1]=='V'||
      fname[strlen(fname)-1]=='v') mode=1;

  stop_wave();
  switch (mode)
   { case 1:   ALoadWaveFile(fname,&lpWave,0);
               AOpenVoices(1);
               ACreateAudioVoice(&hVoice);
               ASetVoiceVolume(hVoice,64);
               ASetVoicePanning(hVoice,128);
               if (APlayVoice(hVoice,lpWave)) {
                  send_message("\nError finded in playing wave"); 
                  stop_wave();
                  break;
               }
               sprintf(word,"\nplaying wave file %s",fname);
               send_message(word);
               break;
     case 2:   ALoadModuleFile(fname,&lpModule,0);
               AOpenVoices(lpModule->nTracks);
               if (APlayModule(lpModule)) {
                  send_message("\nError finded in playing module music");
                  stop_wave();
                  break;
               }
               sprintf(word,"\nplaying module music file %s with %d tracks",fname,lpModule->nTracks);
               send_message(word);
               break;
   }
}

void play_file(char which,short t)
{ char line[200],*name=NULL;
  short tracks=0,i;

  if (t>=selects[which].count) {
     send_message("\nSorry, I have find someting wrong.");
     return;
  }
  
  name=selects[which].names[t]; 

  switch (which)
   { case 0: lmStopMidi();
             if (midi) lmDestroyMidi(midi);
             midi=lmLoadMidi(name,0);
             if (midi) {
                for (i=0,tracks=0;i<MIDI_TRACKS;i++) 
                   if (midi->track[i].len) tracks++;
                sprintf(line,"\nPlaying %s with %d tracks",name,tracks);
                send_message(line);
                lmMidiPlay(midi,FALSE); 
             } else send_message("\nSorry, I can not read this file");
             break;
     case 1: play_a_wave(name);
             break;
     default: send_message(":-("); break;
   }
}

void controller()
{ short done=0,key,t,i,j,m=0;

  while (!done)
   { t=selects[select_win].start+select_line[select_win];
     if (lkpressed()) lkgetch(&key); else key=0;
     AUpdateAudio();
     switch (key)
      { case KEY_ESC: done=1; break;
        case KEY_SPACE: if (select_win==0) lmStopMidi(); 
                        else stop_wave();
                        send_message("\nTo stop it, ok");
                        break;
        case KEY_ENTER: play_file(select_win,t); break;
        case KEY_RIGHT: if (selects[1].count==0) break;
                        select_win=1; 
                        view_selects(0); view_selects(1);
                        break;
        case KEY_LEFT:  if (selects[0].count==0) break;
                        select_win=0;
                        view_selects(0); view_selects(1);
                        break;
        case KEY_UP:  if (t>0) if (--select_line[select_win]<0) {
                         select_line[select_win]=0; selects[select_win].start--;
                      } view_selects(select_win); break;
        case KEY_DOWN:  if (t<selects[select_win].count-1) 
                        if (++select_line[select_win]>win[select_win][3]-win[select_win][1]-2) {
                           select_line[select_win]=win[select_win][3]-win[select_win][1]-2;
                           selects[select_win].start++;
                          }
                        view_selects(select_win);
                      break;
      }
   }
}

void  draw_all()
{ draw_title();  draw_message();
  draw_win(0,1); draw_win(1,1);
}

void  view_selects(char which)
{ short x,y,t,len,color; char *name;
  if (which==select_win) color=14;
     else color=8;
  if (selects[which].count==0) {
    lk_fill_data(win[which][0]+1,win[which][1]+1,win[which][2]-1,win[which][3]-1,' ',0);
    return; 
  }
  lk_setwindow(0,0,79,24);
  if (which==select_win) 
   { for (y=0;y<=win[select_win][3]-win[select_win][1]-2;y++) {
         t=0x7e; if (y==select_line[select_win]) t=0x2e;
         lk_fill_data(win[select_win][0]+1,win[select_win][1]+1+y,
                      win[select_win][2]-1,win[select_win][1]+1+y,t,1);
     }
   } else lk_fill_data(win[which][0],win[which][1],win[which][2],win[which][3],0x78,1);
  for (y=0;y<=win[which][3]-win[which][1]-2;y++) {
    t=y+selects[which].start;
    if (t<selects[which].count) name=selects[which].names[t];
       else name="";
    len=strlen(name); x=win[which][0]+1+len;
    lk_setcolor(color,7);
    if (which==select_win&&y==select_line[which]) lk_setcolor(-1,2);
    lk_gotoxy(win[which][0]+1,win[which][1]+1+y); lk_puts(name);
    while (x<win[which][2]) { lk_write_data(x,win[which][1]+1+y,' ',0); x++; }
  }
}

short load_files(char which)
{ struct find_t fileinfo;
  unsigned rc,i=0,j=0; 
  char names[2][7][10]={
    {"*.MID",""},
    {"*.WAV","*.S3M","*.MOD","MTM","*.XM",""} };
  for (j=0;names[which][j][0]!=0;j++)
    { rc=_dos_findfirst(names[which][j],_A_NORMAL,&fileinfo);
      while (rc==0) 
        { strcpy(selects[which].names[i],fileinfo.name);
          selects[which].sizes[i]=fileinfo.size;
          rc=_dos_findnext(&fileinfo); i++;
        }
    }
  selects[which].count=i; selects[which].start=0;
  return i;
}

void  send_message(char *message)
{ static short x=0,y=0;
  lk_setcolor(8,7);
  lk_setwindow(3,21,77,22);
  lk_gotoxy(x,y);
  lk_puts(message);
  lk_getxy(&x,&y);
}

void draw_message()
{ short i;
  lk_setcolor(8,7);
  lk_draw_window(2,20,78,23,"Message Box",0);
  for (i=3;i<=78;i++) lk_write_data(i,23,0x70,1);
  for (i=20;i<=23;i++) lk_write_data(78,i,0x70,1);
}

void draw_win(char which,char mode)
{ char name[2][20]={ "Midi Files", "Wave Files" };
  short *box=win[which];
  switch (mode)
   { case 0: lk_setcolor(8,7); 
             lk_draw_window(box[0],box[1],box[2],box[3],name[which],0);
             break;
     case 1: lk_setcolor(0,7);
             lk_draw_window(box[0],box[1],box[2],box[3],name[which],1);
             break;
   }
}

void draw_title()
{ short i,j;
  lk_setcolor(15,7);
  lk_draw_window(2,0,78,3," MIDI and WAVE Play Utility, Written By Lin Wei, 2000 ",0);
  for (i=3;i<=78;i++) lk_write_data(i,3,0x70,1);
  for (j=0;j<=3;j++) lk_write_data(78,j,0x78,1);
  lk_setwindow(3,1,77,2); lk_clear(0);
  lk_puts("             Select A .MID .WAV .S3M .MOD .XM .MTM File to Play\n");
  lk_puts("                             Press ESC to Quit       ");
}